Program EprRead;           {Program za branje epromov}
uses crt,dos;

var
  f:file;
  w,d:byte;
  i,ii,la:word;
  adr:word;
  blok:array[0..32767] of byte;

Procedure STROBE259;       begin Port [adr+2]:=3; Port [adr+2]:=1; end;
Procedure STROBE573;       begin Port [adr+2]:=0; Port [adr+2]:=1; end;
Procedure VPG(sw:byte);    begin Port [adr]:=6+(sw xor 1); strobe259; end;
Procedure OE(sw:byte);     begin Port [adr]:=8+sw; strobe259; end;
Procedure CE(sw:byte);     begin Port [adr]:=10+sw; strobe259; end;
Procedure CKA(sw:byte);    begin Port [adr]:=12+sw; strobe259; end;
Procedure CKR(sw:byte);    begin Port [adr]:=14+sw; strobe259; end;
Procedure CLK;             begin Port [adr]:=$1C; strobe259;
                                 Port [adr]:=$1D; strobe259; end;
Procedure Load165;         begin Port [adr]:=$00; Port [adr]:=$10; end;
Procedure Shift165;        begin Port [adr]:=$10; Strobe573;Port [adr]:=$50;
                                 Strobe573; Port [adr]:=$10; Strobe573; end;
Procedure SETadr32(sw:integer);
                           begin Port [adr]:=(sw and 1) or $0;strobe259;
                                 sw:= sw shr(1);
                                 Port [adr]:=(sw and 1) or $2;strobe259;
                                 sw:= sw shr(1);
                                 Port [adr]:=(sw and 1) or $4;strobe259; end;

Procedure SETadr16(sw:integer);
                           begin Port [adr]:=(sw and 1)or $0;strobe259;
                                 sw:= sw shr(1);
                                 Port [adr]:=(sw and 1)or $2;strobe259;
                                 sw:= sw shr(1);
                                 Port [adr]:=5;strobe259; end;

Procedure DefPort;
begin
  adr:=MemW[0:$408];d:=0; Port[adr]:=$aa;Strobe573;Load165;
  for ii:=0 to 7 do begin
      d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
  if d=$55 then begin write('na LPT1'); end
  else begin adr:=MemW[0:$40A];d:=0; Port[adr]:=$aa; Strobe573; Load165;
       for ii:=0 to 7 do begin
           d:=(d+d)+((port[adr+1] and $80) shr (7));Shift165; end;
       if d<>$55 then begin
          WriteLn('Napaka programatorja!'^G); halt(0); end;
       Write('na LPT2') end;
end;

Procedure ParamChk;
begin
 if (ParamCount = 2) and ((ParamStr(2)='27256') or (ParamStr(2)='27128') or
    (ParamStr(2)='2764')) then begin end
 else begin WriteLn('');
            WriteLn('EPRREAD datoteka.bin tip');
            WriteLn('EPRREAD                  ->Ime sistemskega programa');
            WriteLn('        datoteka.bin     ->Ime binarne datoteke');
            WriteLn('                     tip ->Tip eproma');
            WriteLn(''^G); halt (0); end;
end;

{ #### GLAVNI PROGRAM #### }

begin
  writeln('');
  write('(c) AX d.o.o. Julij.1994  Eprom Programator  Ver 1.1 ');
  DefPort; ParamChk;
  Writeln('');
  If ParamStr(2)='27256' then begin
     CKR(1); CLK; VPG(0); CE(1); OE(1);
     SETadr32(0);
     writeln('Vstavi EPROM 27256 v podnoje in pritisni [space]');
     repeat until KeyPressed;
     Writeln('Branje...');
     CKR(0); Port[adr]:=$ff; Strobe573; OE(0); CE(0);
     for i:=0 to 32767 do begin
             SETadr32(i div $1000);
             write(i:5,chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
             Load165; d:=0;
             for ii:=0 to 7 do begin
                 d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
             d:=d xor $ff; Blok[i]:=d; clk;
     end;
     assign(f,ParamStr(1)); rewrite(f,1);
     BlockWrite(f,blok,32768); close(f);
     Writeln('Verifikacija...'); CKR(1); CKR(0);
     for i:=0 to 32767 do begin
             SETadr32(i div $1000); Load165; d:=0;
             write(i:5,chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
             for ii:=0 to 7 do begin
             d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
             d:=d xor $ff;
             if Blok[i]<>d then begin CE(1); OE(1); CKR(1);
                WriteLn('');Writeln('Napaka med branjem'^G); halt(0); end;
             clk;
     end;
     CE(1); OE(1); CKR(1);
     writeln('Branje uspeno konano.')
  end;



  If (ParamStr(2)='27128') or (ParamStr(2)='2764') then begin
     if ParamStr(2)='2764' then la:=8192 else la:=16384;
     CKR(1); CLK; VPG(0); CE(1); OE(1);
     SETadr16(0);
     writeln('Vstavi EPROM ',ParamStr(2),' v podnoje in pritisni [space]');
     repeat until KeyPressed;
     Writeln('Branje...');
     CKR(0); Port[adr]:=$ff; Strobe573; OE(0); CE(0);
     for i:=0 to la-1 do begin
             SETadr16(i div $1000);
             write(i:5,chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
             Load165; d:=0;
             for ii:=0 to 7 do begin
                 d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165;end;
             d:=d xor $ff; Blok[i]:=d; clk;
     end;
     assign(f,ParamStr(1)); rewrite(f,1);
     BlockWrite(f,blok,la); close(f);


     Writeln('Verifikacija...');
     CKR(1); CKR(0);
     for i:=0 to la-1 do begin
             SETadr16(i div $1000); Load165; d:=0;
             write(i:5,chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
             for ii:=0 to 7 do begin
             d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
             d:=d xor $ff;
             if Blok[i]<>d then begin CE(1); OE(1); CKR(1);
                WriteLn('');Writeln('Napaka med branjem'^G); halt(0); end;
             clk;
     end;
     CE(1); OE(1); CKR(1);
     writeln('Branje uspeno konano.')
  end;
writeln('Vzami EPROM iz programatorja.');
end.

